/*Script to call cited-by info from CrossRef and parse it into IR-style cites
© John Austin, Inter-Research 2013, www.int-res.com
*/

function loadXMLDoc(doireq)
{
if(document.getElementById("CitedByDiv").style.display == "block")//these lines open and close the div tag
{
document.getElementById("CitedByDiv").style.display="none";
}
else
{
document.getElementById("CitedByDiv").style.display="block";
//get the domain
var sauce = window.location.hostname;

//set the div element in the html to a temporary result
document.getElementById("CitedByDiv").innerHTML="<br/><i>Calling data from CrossRef...</i><p>";

// query via dedicated proxy avoids cross-domain queries not being allowed
var p_url = 'fileadmin/templates/getcitedby.php?doi=' + encodeURIComponent(doireq) + '&source=' + sauce

function cbFunc(data) {
        // If we have something to work with...
        if (data) {
        xmlRes= (data);
    
// parsing code: 
function loadXMLString(txt) //define function needed to analyse xml strings
{
if (window.DOMParser)
  {
  //xmlDoc=$.parseXML(txt)//alternative jquery method//
  parser=new DOMParser();
  xmlDoc=parser.parseFromString(txt,"text/xml");
  }
else // Internet Explorer before v9
  {
 try
   {
  xmlDoc=new ActiveXObject("Microsoft.XMLDOM");//ie8 standard security blocks this. Browser must be set to allow ActiveX control elements that are not marked as safe
   }
 catch(err)
   {
 document.getElementById("CitedByDiv").innerHTML="<i><br/>Sorry, the cited-by function has been blocked by your browser security settings. Please enable ActiveX or use another browser.</i><p>";
   }
  xmlDoc.async=false;
  xmlDoc.loadXML(txt); 
 }
return xmlDoc;
}

xmlDoc=loadXMLString(xmlRes);// now use the function to analyse xml strings

//define variable that will contain entire output of citations, building citation by citation 
var txtarray = [];

//set tag variable to the main element tag  
var fl=xmlDoc.getElementsByTagName("forward_link");//this element occurs in all cites   
    
if (fl.length == 0 || fl[0].getElementsByTagName("contributors").length == 0) { //if there are no forward link tags or no contributors in first forward link do not process further, but replace with appropriate text (one forward link tag may appear even if no cites)
  document.getElementById("CitedByDiv").innerHTML="<br/><i>No articles citing this article were found by CrossRef</i><br/><br/>"
  }
  else { 
  //cycle through cites  

for (i=0;i<fl.length;i++)
{

//test whether book or other (usually journal)
pubtype=fl[i].getElementsByTagName("book_cite");
if (  pubtype[0] == undefined) {
pubtype="jour"
}
else {
pubtype="bk"
}
// possible cite types: "journal_cite" "conf_cite" "book_cite" "dissertation_cite" "report_cite" "standard_cite" "database_cite" "msg"

//parse author names
contribs=fl[i].getElementsByTagName("contributor");//the contributors for this article

try {
 var  auths=""  //define the variable for author list, which will build up as we loop through contributors

  jmax=contribs.length;
  if(jmax > 7) {
  jmax = 5;
  }
   for (j=0;j<jmax;j++)//loop through contributors; limit to 7, if more give 4 'and x others'
   {
   if (contribs.length > 7 && j == 4) {
   sname = "and " + (contribs.length - 4) + " others"
   gname = ""
   suff = ""
   }
   else{
   //get given name and surname and suffix -- if absent set to empty string
   try {gname=contribs[j].getElementsByTagName("given_name")[0].childNodes[0].nodeValue; }
   catch(err) { gname =""; }
 
   try { sname=contribs[j].getElementsByTagName("surname")[0].childNodes[0].nodeValue; }
   catch(err) {sname ="";}  
   
   try { suff=contribs[j].getElementsByTagName("suffix")[0].childNodes[0].nodeValue; }
   catch(err) {suff ="";}
   
   //...and reduce given names to initials 
   //Following five styles for given names are covered: "M D", "MD", "M.D.", "M. D.", "Michael David"
   var gname=gname.replace(".",". ");  //replace full stops with fullstop-space
   gname=gname.replace(".",""); //remove full stops
   gname=gname.replace("  "," ");   //replace any double spaces by single spaces
   gname=gname.split(" ");  //convert to array, separated by spaces
   for (g=0;g<gname.length;g++) //for each item in array, reduce to single letter, but only if second letter is not upper case (style 2)
   {
   if (gname[g][1] != undefined && gname[g][1].toLowerCase() == gname[g][1])
   gname[g]=gname[g].slice(0,1);
   }
   gname=gname.join("");//join array back to string
   }
//assemble author list   
   if (j==jmax - 1) {
   auths=auths + sname + " " + gname + " " + suff 
     }
   else {
   auths=auths + sname + " " + gname + suff + ", "// only put in the comma if not last author
      }
  }
  }
 catch(err) {
 auths = "-- "  //in case of error, set authors to "--"
}
 if (auths == "") {
 auths = "?? "  //in case no contributors, set authors to "??"
}
 
 
 //try to set variable for each elememt. If element is missing, set to empty string or dash
 try { vo_i=fl[i].getElementsByTagName("volume")[0].childNodes[0].nodeValue ; }
 catch(err) { vo_i =""; }
 
try { fp_i=fl[i].getElementsByTagName("first_page")[0].childNodes[0].nodeValue; 
 if (fp_i == "n/a" || fp_i == "na" || fp_i == "n.a." || fp_i == "000" || fp_i == "00") {
 fp_i = ""; }
 if (fp_i == "1" && vo_i == "") { //occurs for Cambridge FirstView
 fp_i = "";
 }} 
catch(err) { fp_i =""; }
    
 try { yr_i=fl[i].getElementsByTagName("year")[0].childNodes[0].nodeValue ; }
 catch(err) { yr_i =""; }
  
 try { ti_i=fl[i].getElementsByTagName("article_title")[0].childNodes[0].nodeValue;//if journal
 if (ti_i.charAt( ti_i.length-1 ) == "." || ti_i.charAt( ti_i.length-1 ) == "?" || ti_i.charAt( ti_i.length-1 ) == "!") { //avoid adding "." if "?" etc present
 }
 else { ti_i = ti_i + ". "; }
 }
 catch(err) {
   try {ti_i=fl[i].getElementsByTagName("volume_title")[0].childNodes[0].nodeValue;//if book
   if (ti_i.charAt( ti_i.length-1 ) == "." || ti_i.charAt( ti_i.length-1 ) == "?" || ti_i.charAt( ti_i.length-1 ) == "!") { //avoid adding "." if "?" etc present
 ti_i = ti_i + " "; }
 else { ti_i = ti_i + ". "; }
    }
   catch(err) {   ti_i =""; }
 }
 
 try { ser_i=fl[i].getElementsByTagName("series_title")[0].childNodes[0].nodeValue + ". "; }
 catch(err) { ser_i =""; }
 
 try { jl_i=fl[i].getElementsByTagName("journal_title")[0].childNodes[0].nodeValue; 
 if (vo_i !== "" || fp_i !== "") {
 jl_i = jl_i + " "; //only add space if vol or 1stpage present
 }}
 catch(err) { jl_i =""; }
 
 try { itn_i=fl[i].getElementsByTagName("item_number")[0].childNodes[0].nodeValue ; // for AGU
 itn_i = ", " + itn_i;}
 catch(err) { itn_i =""; }
 
 try { citdoi_i=fl[i].getElementsByTagName("doi")[0].childNodes[0].nodeValue; }
 catch(err) { citdoi_i ="--"; }
 
  //  assemble complete cite and add to the variable txtarray
  if (pubtype == "jour" ) {  //for journals and other types
    if (fp_i !== "") {
    fp_i = ":" + fp_i; //only add colon if page present
    }
     txtcite=auths + "(" + yr_i + ") " + ti_i + ser_i + jl_i + vo_i + itn_i + fp_i + 
     ", doi:<a href='http://dx.doi.org/" + citdoi_i + "' target='blank'>" + citdoi_i + "</a><br/><br/>";
     }
     else { //for books
     //add word "Vol" if vol present. and add comma before page
     if (vo_i !== "") {vo_i = "Vol " + vo_i + ", ";} 
    txtcite=auths + "(" + yr_i + ") " + ti_i + ser_i + jl_i + vo_i + "p " + fp_i + 
     ", doi:<a href='http://dx.doi.org/" + citdoi_i + "' target='blank'>" + citdoi_i + "</a><br/><br/>";  
     }
txtarray.push(txtcite);//build result array
}// end of loop with i

function charOrd(strA, strB){ // function to make sorting ignore case
strA = strA.toLowerCase(); strB = strB.toLowerCase();
if (strA.substr(0,2) == "??" || strA.substr(0,2) == "--" ) return 1;//put "??" and "--" to end
if (strB.substr(0,2) == "??" || strA.substr(0,2) == "--" ) return -1;
if (strA > strB) return 1;
if (strA < strB) return -1;
return 0; }

txtarray.sort(charOrd);//sort alphabetically, ignoring case

txtarray = txtarray.join("");//convert to string

//set the div element in the html to the result
document.getElementById("CitedByDiv").innerHTML="<br/><i>This article is cited by the following articles linked in CrossRef:</i><br/><br/>" + txtarray;
  
}//end of: if there are forward links in result
  
}//end of if we have smthg to work with  
} // end of function cbFunc
  
$.get(p_url, cbFunc);//ajax function; requires loading jQuery 1.8

}// end of else near top
}//end of loadxmldoc
